# Class JacocoPluginExtension

java.lang.Object
org.gradle.testing.jacoco.plugins.JacocoPluginExtension

public abstract class JacocoPluginExtension extends Object
Extension including common properties and methods for Jacoco.

Since:
  1.6

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `TASK_EXTENSION_NAME`
  The task extension name.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `JacocoPluginExtension(Project project, org.gradle.internal.jacoco.JacocoAgentJar agent)`
  Creates a Jacoco plugin extension.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `<T extends Task & JavaForkOptions>
  void`
  `applyTo(TaskCollection<T> tasks)`
  Applies Jacoco to all of the given tasks.
  `<T extends Task & JavaForkOptions>
  void`
  `applyTo(T task)`
  Applies Jacoco to the given task.
  `abstract DirectoryProperty`
  `getReportsDirectory()`
  The directory where reports will be generated.
  `String`
  `getToolVersion()`
  Version of Jacoco JARs to use.
  `void`
  `setToolVersion(String toolVersion)`
  Sets the tool version.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### TASK_EXTENSION_NAME

    public static final String TASK_EXTENSION_NAME
    The task extension name.
    Since:
      2.14
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### JacocoPluginExtension

    @Inject public JacocoPluginExtension(Project project, org.gradle.internal.jacoco.JacocoAgentJar agent)
    Creates a Jacoco plugin extension.
    Parameters:
      `project` - the project the extension is attached to
      `agent` - the agent JAR to be used by Jacoco

- ## Method Details

  - ### getToolVersion

    public String getToolVersion()
    Version of Jacoco JARs to use.
    Since:
      1.6

  - ### setToolVersion

    public void setToolVersion(String toolVersion)
    Sets the tool version.
    Since:
      1.6

  - ### getReportsDirectory

    public abstract DirectoryProperty getReportsDirectory()
    The directory where reports will be generated.
    Since:
      6.8

  - ### applyTo

    public <T extends Task & JavaForkOptions> void applyTo(T task)
    Applies Jacoco to the given task. Configuration options will be provided on a task extension named 'jacoco'. Jacoco will be run as an agent during the execution of the task.
    Parameters:
      `task` - the task to apply Jacoco to.
    Since:
      2.14
    See Also:
      - `TASK_EXTENSION_NAME`

  - ### applyTo

    public <T extends Task & JavaForkOptions> void applyTo(TaskCollection<T> tasks)
    Applies Jacoco to all of the given tasks.
    Parameters:
      `tasks` - the tasks to apply Jacoco to
    Since:
      1.6